<script setup lang="ts">
import { reactive, onMounted } from 'vue'
import AppCard from './ui/AppCard.vue'
import { Modal } from 'flowbite'

import exampleCS from '@/assets/yb_example_cs.jpg'
import exampleMTE from '@/assets/yb_example_mte.jpg'
import type { ModalOptions } from 'flowbite/lib/esm/components/modal/types'

const props = defineProps<{
  dense?: boolean
}>()

const state = reactive({
  previewBackground: 'bg-gray-300',
  examplePreviewSrc: ''
})

let modal: Modal
onMounted(() => {
  const modalEl = document.getElementById('example-preview-modal')
  const modalOptions: ModalOptions = {
    placement: 'center',
    backdrop: 'dynamic',
    backdropClasses: 'bg-gray-900/50 dark:bg-gray-900/80 fixed inset-0 z-40',
    closable: true
  }
  modal = new Modal(modalEl, modalOptions)
})

function showExample(src: string) {
  state.examplePreviewSrc = src
  modal.show()
}

function closeExample() {
  modal.hide()
}
</script>

<template>
  <div class="flex justify-evenly">
    <AppCard class="grow" :dense="props.dense" :title="$t('preview.examples')">
      <div :class="`grow flex space-x-3 justify-around`">
        <div>
          <img
            :class="`cursor-pointer hover:opacity-80`"
            :src="exampleCS"
            @click="() => showExample(exampleCS)"
          />
        </div>
        <div>
          <img
            :class="`cursor-pointer hover:opacity-80`"
            :src="exampleMTE"
            @click="() => showExample(exampleMTE)"
          />
        </div>
      </div>
    </AppCard>

    <!-- Example preview modal -->
    <div
      id="example-preview-modal"
      @click="closeExample"
      tabindex="-1"
      class="fixed top-0 left-0 right-0 z-50 hidden w-full p-4 overflow-x-hidden overflow-y-auto md:inset-0 h-[calc(100%-1rem)] max-h-full"
    >
      <div class="relative w-full max-w-7xl max-h-full">
        <!-- Modal content -->
        <div class="relative bg-white rounded-lg shadow dark:bg-gray-700">
          <!-- Modal header -->
          <div
            class="flex items-center justify-between p-4 md:p-5 border-b rounded-t dark:border-gray-600"
          >
            <h3 class="text-xl font-medium text-gray-900 dark:text-white">
              {{ $t('preview.exampleModalTitle') }}
            </h3>
            <button
              type="button"
              class="text-gray-400 bg-transparent hover:bg-gray-200 hover:text-gray-900 rounded-lg text-sm w-8 h-8 ms-auto inline-flex justify-center items-center dark:hover:bg-gray-600 dark:hover:text-white"
            >
              <svg
                class="w-3 h-3"
                aria-hidden="true"
                xmlns="http://www.w3.org/2000/svg"
                fill="none"
                viewBox="0 0 14 14"
              >
                <path
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  stroke-width="2"
                  d="m1 1 6 6m0 0 6 6M7 7l6-6M7 7l-6 6"
                />
              </svg>
            </button>
          </div>
          <!-- Modal body -->
          <div class="p-4 md:p-5 space-y-4">
            <img :src="state.examplePreviewSrc" />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped>
@keyframes pulse {
  0%,
  100% {
    text-decoration-color: transparent;
  }

  50% {
    text-decoration-color: #c63838;
  }
}

.custom-animate-pulse {
  text-decoration: underline;
  text-decoration-style: dotted;
  text-decoration-thickness: 2px;
  animation: pulse 1s cubic-bezier(0.4, 0, 0.6, 1) infinite;
}
</style>
